'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StyleSheetManager = exports.ServerStyleSheet = exports.withTheme = exports.ThemeProvider = exports.isStyledComponent = exports.injectGlobal = exports.css = undefined;

var _styledComponents = require('styled-components');

var _StyledNativeComponent = require('styled-components/lib/models/StyledNativeComponent');

var _StyledNativeComponent2 = _interopRequireDefault(_StyledNativeComponent);

var _constructWithOptions = require('styled-components/lib/constructors/constructWithOptions');

var _constructWithOptions2 = _interopRequireDefault(_constructWithOptions);

var _domElements = require('styled-components/lib/utils/domElements');

var _domElements2 = _interopRequireDefault(_domElements);

var _mailStyle = require('./mail-style');

var _mailStyle2 = _interopRequireDefault(_mailStyle);

var _styledComponent = require('./styled-component');

var _styledComponent2 = _interopRequireDefault(_styledComponent);

var _stylesheet = require('./stylesheet');

var _stylesheet2 = _interopRequireDefault(_stylesheet);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var InlineStyle = (0, _mailStyle2.default)(_stylesheet2.default);
var constructWithOptions = (0, _constructWithOptions2.default)(_styledComponents.css);
var createStyledComponent = (0, _StyledNativeComponent2.default)(constructWithOptions, InlineStyle);
var styled = function styled(element) {
  return constructWithOptions(createStyledComponent, element, { ParentComponent: _styledComponent2.default });
};

// Set html element aliases
[].concat(_toConsumableArray(_domElements2.default), ['center', 'font']).forEach(function (element) {
  return Object.defineProperty(styled, element, {
    enumerable: true,
    configurable: false,
    get: function get() {
      return styled(element);
    }
  });
});

// Set VML (v:*), WML (w:*) and Office (o:*) dynamic aliases
['vml', 'wml', 'office'].forEach(function (namespace) {
  Object.defineProperty(styled, namespace, {
    enumerable: true,
    configurable: false,
    get: function get() {
      var target = {};
      return new Proxy(target, {
        get: function get(object, property) {
          if (property in object) {
            return object[property];
          }
          if (typeof property === 'string') {
            return styled(namespace.charAt(0) + ':' + property);
          }
          return undefined;
        }
      });
    }
  });
});

exports.default = styled;
exports.css = _styledComponents.css;
exports.injectGlobal = _styledComponents.injectGlobal;
exports.isStyledComponent = _styledComponents.isStyledComponent;
exports.ThemeProvider = _styledComponents.ThemeProvider;
exports.withTheme = _styledComponents.withTheme;
exports.ServerStyleSheet = _styledComponents.ServerStyleSheet;
exports.StyleSheetManager = _styledComponents.StyleSheetManager;