'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _colorShorthandHexToSixDigit = require('color-shorthand-hex-to-six-digit');

var _colorShorthandHexToSixDigit2 = _interopRequireDefault(_colorShorthandHexToSixDigit);

var _InlineStyle2 = require('styled-components/lib/models/InlineStyle');

var _InlineStyle3 = _interopRequireDefault(_InlineStyle2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

exports.default = function (stylesheet) {
  var InlineStyle = (0, _InlineStyle3.default)(stylesheet);
  return function (_InlineStyle) {
    _inherits(InlineMailStyle, _InlineStyle);

    function InlineMailStyle() {
      _classCallCheck(this, InlineMailStyle);

      return _possibleConstructorReturn(this, (InlineMailStyle.__proto__ || Object.getPrototypeOf(InlineMailStyle)).apply(this, arguments));
    }

    _createClass(InlineMailStyle, [{
      key: 'generateStyleObject',
      value: function generateStyleObject(executionContext) {
        var styleId = _get(InlineMailStyle.prototype.__proto__ || Object.getPrototypeOf(InlineMailStyle.prototype), 'generateStyleObject', this).call(this, executionContext);
        var style = stylesheet.resolve(styleId);
        return Object.keys(style).reduce(function (acc, rule) {
          // Transform unitless numbers to pixels
          if (typeof style[rule] === 'number') {
            return _extends({}, acc, _defineProperty({}, rule, style[rule] + 'px'));
          }
          // Expand hex colors
          if (rule.toLowerCase().includes('color')) {
            return _extends({}, acc, _defineProperty({}, rule, (0, _colorShorthandHexToSixDigit2.default)(style[rule])));
          }
          return _extends({}, acc, _defineProperty({}, rule, style[rule]));
        }, {});
      }
    }]);

    return InlineMailStyle;
  }(InlineStyle);
};