'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _ThemeProvider = require('styled-components/lib/models/ThemeProvider');

var _isStyledComponent = require('styled-components/lib/utils/isStyledComponent');

var _isStyledComponent2 = _interopRequireDefault(_isStyledComponent);

var _determineTheme = require('styled-components/lib/utils/determineTheme');

var _determineTheme2 = _interopRequireDefault(_determineTheme);

var _validAttr = require('styled-components/lib/utils/validAttr');

var _validAttr2 = _interopRequireDefault(_validAttr);

var _isTag = require('styled-components/lib/utils/isTag');

var _isTag2 = _interopRequireDefault(_isTag);

var _stylesheet = require('./stylesheet');

var _stylesheet2 = _interopRequireDefault(_stylesheet);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// Based on:
// https://github.com/styled-components/styled-components/blob/master/src/models/StyledNativeComponent.js#L22
var StyledMailComponent = function (_React$Component) {
  _inherits(StyledMailComponent, _React$Component);

  function StyledMailComponent() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, StyledMailComponent);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = StyledMailComponent.__proto__ || Object.getPrototypeOf(StyledMailComponent)).call.apply(_ref, [this].concat(args))), _this), _this.unsubscribeId = -1, _this.attrs = {}, _this.state = {
      theme: null,
      generatedStyles: undefined
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(StyledMailComponent, [{
    key: 'unsubscribeFromContext',
    value: function unsubscribeFromContext() {
      if (this.unsubscribeId !== -1) {
        this.context[_ThemeProvider.CHANNEL_NEXT].unsubscribe(this.unsubscribeId);
      }
    }
  }, {
    key: 'buildExecutionContext',
    value: function buildExecutionContext(theme, props) {
      var attrs = this.constructor.attrs;

      var context = _extends({}, props, { theme: theme });
      if (attrs === undefined) {
        return context;
      }
      this.attrs = Object.keys(attrs).reduce(function (acc, key) {
        var attr = attrs[key];
        return _extends({}, acc, _defineProperty({}, key, typeof attr === 'function' ? attr(context) : attr));
      }, {});
      return _extends({}, context, this.attrs);
    }
  }, {
    key: 'generateAndInjectStyles',
    value: function generateAndInjectStyles(theme, props) {
      var inlineStyle = this.constructor.inlineStyle;

      var executionContext = this.buildExecutionContext(theme, props);
      return inlineStyle.generateStyleObject(executionContext);
    }
  }, {
    key: 'componentWillMount',
    value: function componentWillMount() {
      var _this2 = this;

      var styledContext = this.context[_ThemeProvider.CHANNEL_NEXT];
      if (styledContext !== undefined) {
        var subscribe = styledContext.subscribe;

        this.unsubscribeId = subscribe(function (nextTheme) {
          var theme = (0, _determineTheme2.default)(_this2.props, nextTheme, _this2.constructor.defaultProps);
          var generatedStyles = _this2.generateAndInjectStyles(theme, _this2.props);
          _this2.setState({ theme: theme, generatedStyles: generatedStyles });
        });
      } else {
        var theme = this.props.theme || {};
        var generatedStyles = this.generateAndInjectStyles(theme, this.props);
        this.setState({ theme: theme, generatedStyles: generatedStyles });
      }
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var _this3 = this;

      this.setState(function (prevState) {
        var theme = (0, _determineTheme2.default)(nextProps, prevState.theme, _this3.constructor.defaultProps);
        var generatedStyles = _this3.generateAndInjectStyles(theme, nextProps);
        return { theme: theme, generatedStyles: generatedStyles };
      });
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.unsubscribeFromContext();
    }
  }, {
    key: 'render',
    value: function render() {
      var generatedStyles = this.state.generatedStyles;
      var target = this.constructor.target;

      var props = _extends({}, this.attrs, this.props, {
        style: [generatedStyles, this.attrs.style, this.props.style]
      });
      var nextProps = Object.keys(props).reduce(function (acc, prop) {
        switch (prop) {
          // Flatten out and resovle all styles
          case 'style':
            return _extends({}, acc, { style: _stylesheet2.default.flatten(props.style) });
          // Prevent innerRef of DOM elements
          case 'innerRef':
            var innerRef = props[prop];
            if ((0, _isTag2.default)(target)) {
              return acc;
            }
            if ((0, _isStyledComponent2.default)(target)) {
              return _extends({}, acc, { innerRef: innerRef });
            }
            return _extends({}, acc, { ref: innerRef });
          // Prevent non-valid DOM attributes
          default:
            if (!(0, _isTag2.default)(target) || (0, _validAttr2.default)(prop)) {
              return _extends({}, acc, _defineProperty({}, prop, props[prop]));
            }
            return acc;
        }
      }, {});
      return _react2.default.createElement(target, nextProps);
    }
  }]);

  return StyledMailComponent;
}(_react2.default.Component);

StyledMailComponent.target = null;
StyledMailComponent.styledComponentId = '';
StyledMailComponent.attrs = {};
StyledMailComponent.defaultProps = {};
StyledMailComponent.inlineStyle = {};
exports.default = StyledMailComponent;